/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util;

import java.text.DecimalFormat;

public class DataUtil {
    public static final String DATA_NULL_VALUE = "--";
    public static final int PERCENT_DECIMAL = 1;

    public static int compare(Object o1, Object o2) {
        double d2;
        if (o1 == null && o2 == null) {
            return 0;
        }
        if (o1 == null) {
            return -1;
        }
        if (o2 == null) {
            return 1;
        }
        double d1 = (Double)o1;
        if (d1 < (d2 = ((Double)o2).doubleValue())) {
            return -1;
        }
        if (d1 > d2) {
            return 1;
        }
        return 0;
    }

    public static String getDigitValue(int demical, double src) {
        DecimalFormat df = new DecimalFormat();
        StringBuffer buff = new StringBuffer();
        buff.append("#");
        if (demical > -1) {
            if (demical > 0) {
                buff.append("0.");
            } else {
                buff.append("#");
            }
            int i = 0;
            while (i < demical) {
                buff.append("0");
                ++i;
            }
        } else {
            buff.append("#.#####");
        }
        df.applyPattern(buff.toString());
        return df.format(src);
    }

    public static boolean isDataValue(Object value) {
        if (value == null) {
            return false;
        }
        if (value instanceof Double) {
            return true;
        }
        if (value instanceof Integer) {
            return true;
        }
        if (value instanceof Float) {
            return true;
        }
        if (value instanceof Long) {
            return true;
        }
        return value instanceof Short;
    }

    public static Double divide(Object o1, Object o2) {
        if (o1 == null) {
            return new Double(0.0);
        }
        if (o2 == null) {
            return null;
        }
        if (DataUtil.isDataValue(o1)) {
            double v1 = (Double)o1;
            double v2 = (Double)o2;
            if (v2 == 0.0) {
                return null;
            }
            return new Double(v1 / v2);
        }
        return null;
    }

    public static Object calcSum(Object[] values) {
        if (values == null || values.length == 0) {
            return null;
        }
        Object validObj = null;
        int i = 0;
        while (i < values.length) {
            if (values[i] != null) {
                validObj = values[i];
                break;
            }
            ++i;
        }
        if (validObj == null) {
            return null;
        }
        if (validObj instanceof Double) {
            double returnValue = 0.0;
            int i2 = 0;
            while (i2 < values.length) {
                if (values[i2] != null) {
                    returnValue += ((Double)values[i2]).doubleValue();
                }
                ++i2;
            }
            return new Double(returnValue);
        }
        if (validObj instanceof Integer || validObj instanceof Long || validObj instanceof Short) {
            long returnValue = 0L;
            int i3 = 0;
            while (i3 < values.length) {
                if (values[i3] != null) {
                    returnValue += (long)((Integer)values[i3]).intValue();
                }
                ++i3;
            }
            return new Long(returnValue);
        }
        if (validObj instanceof Float) {
            float returnValue = 0.0f;
            int i4 = 0;
            while (i4 < values.length) {
                if (values[i4] != null) {
                    returnValue += ((Float)values[i4]).floatValue();
                }
                ++i4;
            }
            return new Float(returnValue);
        }
        return "";
    }

    public static int[] calcPlace(Object[] values) {
        if (values == null) {
            return null;
        }
        if (values.length == 0) {
            return new int[0];
        }
        int[] returnPlace = new int[values.length];
        int i = 0;
        while (i < values.length) {
            int p = 1;
            int j = 0;
            while (j < values.length) {
                if (j != i && DataUtil.compare(values[j], values[i]) > 0) {
                    ++p;
                }
                ++j;
            }
            returnPlace[i] = p;
            ++i;
        }
        return returnPlace;
    }

    public static boolean isLessthanOrEqualZeroData(Object value) {
        if (DataUtil.isNegativeData(value)) {
            return true;
        }
        if (!DataUtil.isDataValue(value)) {
            return true;
        }
        double d = (Double)value;
        return d == 0.0;
    }

    public static boolean isNegativeData(Object value) {
        if (!DataUtil.isDataValue(value)) {
            return true;
        }
        double d = (Double)value;
        return d < 0.0;
    }

    public static boolean isZeroData(Object value) {
        if (!DataUtil.isDataValue(value)) {
            return false;
        }
        double d = (Double)value;
        return d == 0.0;
    }

    public static String[] calcPercent(Object[] values) {
        if (values == null) {
            return null;
        }
        if (values.length == 0) {
            return new String[0];
        }
        String[] returnPercent = new String[values.length];
        int i = 0;
        while (i < values.length) {
            if (DataUtil.isNegativeData(values[i])) {
                int j = 0;
                while (j < values.length) {
                    returnPercent[j] = DATA_NULL_VALUE;
                    ++j;
                }
                return returnPercent;
            }
            ++i;
        }
        Object sumValue = DataUtil.calcSum(values);
        if (sumValue != null) {
            if (DataUtil.isLessthanOrEqualZeroData(sumValue)) {
                int i2 = 0;
                while (i2 < values.length) {
                    returnPercent[i2] = DATA_NULL_VALUE;
                    ++i2;
                }
                return returnPercent;
            }
            int specialPercentIndex = -1;
            double otherPercentValue = 0.0;
            boolean notSpecialDealed = true;
            Object value = null;
            int i3 = 0;
            while (i3 < values.length) {
                value = values[i3];
                if (value == null) {
                    returnPercent[i3] = DATA_NULL_VALUE;
                } else if (!DataUtil.isZeroData(value) && notSpecialDealed) {
                    specialPercentIndex = i3;
                    notSpecialDealed = false;
                } else {
                    value = DataUtil.divide(value, sumValue);
                    try {
                        double percent = 100.0 * (Double)value;
                        String percentStr = DataUtil.getDigitValue(1, percent);
                        returnPercent[i3] = String.valueOf(percentStr) + "%";
                        try {
                            otherPercentValue += Double.parseDouble(percentStr);
                        }
                        catch (NumberFormatException numberFormatException) {}
                    }
                    catch (Exception exception) {}
                }
                ++i3;
            }
            if (specialPercentIndex >= 0) {
                returnPercent[specialPercentIndex] = String.valueOf(DataUtil.getDigitValue(1, 100.0 - otherPercentValue)) + "%";
            }
        }
        return returnPercent;
    }
}

